---
proxy:
  service:
    type: {{ jhub_common_values.proxy.service.type }}
  chp:
    resources:
      requests:
        cpu: 200m
        memory: 512Mi
scheduling:
  userScheduler:
    enabled: false

cull:
  timeout: 900

hub:
  image:
    name: {{ hub_image_name }}
    {% if item.hub_image_tag is defined %}

    tag: {{ item.hub_image_tag }}
    {% else %}
    
    tag: {{ hub_image_tag }}
    {% endif %}

  db:
    type: {{ jhub_common_values.hub.db.type }}
    {% if item.dbStorageClass is defined %}

    pvc:
      storageClassName: {{ item.dbStorageClass }}
    {% endif %}

  resources:
    requests:
      cpu: 200m
      memory: 512Mi

  config:
    LTI11Authenticator:
      consumers: {
        "{{ item.lti.key }}": "{{ item.lti.secret }}"
        }
      {% if item.lti_username_attribute is defined %}

      username_key: "{{ item.lti_username_attribute }}"
      {% elif lti_username_attribute is defined %}

      username_key: "{{ lti_username_attribute }}"
      {% else %}
      
      username_key: "lis_person_sourcedid"
      {% endif %}

    JupyterHub:
      authenticator_class: ltiauthenticator.LTI11Authenticator

      {% if inactive_state is defined %}
      
      template_vars:
        announcement: This JupyterHub is in <i>inactive</i> state. It may be used to access historic data, but not for production. It will eventually be archived and uninstalled.
      {% endif %}
      {% if archived_state is defined %}
      
      template_vars:
        announcement: This JupyterHub is in <i>archived</i> state. It has been temporarely reenabled, and will be shut down again.
      {% endif %}

  extraConfig:
    myAuthConfig: |
      from ltiauthenticator import LTIAuthenticator
      c.JupyterHub.authenticator_class = LTIAuthenticator
      
    {% if item.externalMounts is defined %}
    
    kubevol: |
        from kubespawner.utils import get_k8s_model
        from kubernetes.client.models import ( V1Volume, V1VolumeMount )
        def modify_pod_hook(spawner, pod):
            ext_mounts = {{ item.externalMounts }}
            try:
                for mnt in ext_mounts:
                            pod.spec.volumes.append(
                                get_k8s_model(V1Volume,
                                 { 'name' : mnt['name'],
                                   'nfs': { 'server' : mnt['server'],
                                            'path' : mnt['path'] }
                                 })
                            )
                            # Note implicitly only 1 container...
                            pod.spec.containers[0].volume_mounts.append(
                              get_k8s_model(V1VolumeMount,
                                  { 'name' : mnt['name'], 'mountPath': mnt['dest'] } )
                            )
            except Exception as e:
                spawner.log.info("Exception in shared-mounts" + str(e))
                pass
            return pod
        c.KubeSpawner.modify_pod_hook = modify_pod_hook
    {% endif %}

prePuller:
  continuous:
    enabled: False
  hook:
    enabled: {{ jhub_common_values.prePuller.hook.enabled }}
    resources:
      requests:
        cpu: 0
        memory: 0
  resources:
    requests:
      cpu: 0
      memory: 0
ingress:
  enabled: {{ jhub_common_values.ingress.enabled }}
  annotations:
    kubernetes.io/ingress.class: "nginx"
    nginx.ingress.kubernetes.io/proxy-body-size: 64m
    cert-manager.io/cluster-issuer: letsencrypt-production
    alias-managed: "true"
  hosts:
    - {{ item.name }}.{{ domain }}
  tls:
    - hosts:
        - {{ item.name }}.{{ domain }}
      secretName: {{ item.name }}-tls
singleuser:
  image:
    name: {{ item.images[0].image }}
    tag: {{ item.images[0].tag }}

    {% if item.imagePullPolicy is defined %}

    pullPolicy: {{ item.imagePullPolicy }}

    {% endif %}

  lifecycleHooks:
    postStart:
      exec:
        command: ["mkdir", "-p", "assignments"]

  defaultUrl: {{ item.defaultUrl }}
  extraEnv:
    TF_CPP_MIN_LOG_LEVEL: "2"
    {% if item.extraVars is defined -%}
    {% for var in item.extraVars -%}
    {{ var.name }}: "{{ var.value }}"
    {% endfor %}
    {% endif %}
    
  memory:
    guarantee: {{ item.memory.guarantee }}
    limit: {{ item.memory.limit }}
    
  {% if item.cpu is defined %}
  
  cpu:
    guarantee: {{ item.cpu.guarantee }}
    limit: {{ item.cpu.limit }}

  {% endif %}

  storage:
    type: static
    capacity: {{ item.homeSize }}
    static:
      pvcName: {{ item.name }}-claim
    # extraVolumes:
    # - name: shared
    #   persistentVolumeClaim:
    #     claimName: {{ item.name }}-shared-claim
    # extraVolumeMounts:
    # - name: shared
    #   mountPath: /home/jovyan/shared

{% if item.images | length > 1 %}
  profileList:
  {% for notebook in item.images %}
  - display_name: {{ notebook.display_name }}
      description: {{ notebook.description }}
      kubespawner_override:
        image: {{ notebook.image }}:{{ notebook.tag }}
  {% endfor %}
  {% endif %}

{% if netpol_blacklist | length > 0 %}
  networkPolicy:
    enabled: true
    egress:
      - to:
        - ipBlock:
            cidr: 0.0.0.0/0
            except:
              - 169.254.169.254/32
              {% for subnet in netpol_blacklist -%}
              - {{ subnet }}
              {% endfor %}
{% endif %}
